using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.IO;

namespace ADX_Ol_Event_ItemSend_CS
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("892C3AD3-FCBD-4C08-B05F-AEA63AD8DE2E"), ProgId("ADX_Ol_Event_ItemSend_CS.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
        private AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
        private AddinExpress.OL.ADXOlFormsCollectionItem adxOlFormsCollectionItem1;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxOlFormsCollectionItem1 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
            this.adxOutlookEvents.ItemSend += new AddinExpress.MSO.ADXOlItemSend_EventHandler(this.adxOutlookEvents_ItemSend);
            // 
            // adxOlFormsManager1
            // 
            this.adxOlFormsManager1.Items.Add(this.adxOlFormsCollectionItem1);
            this.adxOlFormsManager1.SetOwner(this);
            // 
            // adxOlFormsCollectionItem1
            // 
            this.adxOlFormsCollectionItem1.FormClassName = "ADX_Ol_Event_ItemSend_CS.ADXOlForm1";
            this.adxOlFormsCollectionItem1.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olMail;
            this.adxOlFormsCollectionItem1.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.RightSubpane;
            // 
            // AddinModule
            // 
            this.AddinName = "ADX_Ol_Event_ItemSend_CS";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
        {
            Outlook._MailItem mailItem = (inspector as Outlook.Inspector).CurrentItem as Outlook._MailItem;
            if (mailItem != null)
                try
                {
                    adxOlFormsManager1.Items[0].Enabled = !mailItem.Sent;
                }
                finally
                {
                    Marshal.ReleaseComObject(mailItem);
                }
        }

        private void adxOutlookEvents_ItemSend(object sender, AddinExpress.MSO.ADXOlItemSendEventArgs e)
        {
            e.Cancel = false;
            Outlook._MailItem mailItem = e.Item as Outlook._MailItem;
            if (mailItem != null)
            {
				ADXOlForm1 olForm = adxOlFormsCollectionItem1.GetCurrentForm(AddinExpress.OL.EmbeddedFormStates.Visible) as ADXOlForm1;
                mailItem.Save();
                if (!mailItem.Sent)
                {
                    if (olForm.checkBoxAddRecipient.Checked)
                    {
                        mailItem.Recipients.Add(olForm.textBoxAddRecipient.Text);
                    }
                    if (olForm.checkBoxModifySubject.Checked)
                    {
                        mailItem.Subject = mailItem.Subject + "  " + DateTime.Now.ToString();
                    }
                    if (olForm.checkBoxAddTextBody.Checked)
                    {
                        DoAddTextBody(mailItem, olForm);
                    }
                    if (olForm.checkBoxAddAttachment.Checked)
                    {
                        DoAddAttachment(mailItem, olForm);
                    }
                    if (olForm.checkBoxSaveMailItemFolder.Checked)
                    {
                        DoSaveMailItemFolder(mailItem, olForm);
                    }
                    if (olForm.checkBoxSaveMailItemFile.Checked)
                    {
                        DoSaveMailItemFile(mailItem, olForm);
                    }
                    if (olForm.checkBoxForbidSending.Checked)
                    {
                        e.Cancel = true;
                        System.Windows.Forms.MessageBox.Show("Action canceled!");
                    }
                }
            }
        }

        private void DoAddTextBody(Outlook._MailItem mailItem, ADXOlForm1 olForm)
        {
            int startIndex = mailItem.Body.Length;
            mailItem.Body = mailItem.Body.Insert(startIndex, olForm.textBoxAddTextBody.Text);
        }

        private void DoAddAttachment(Outlook._MailItem mailItem, ADXOlForm1 olForm)
        {
            string pathFileOpen = olForm.textBoxAddAttachment.Text;
            mailItem.Attachments.Add(pathFileOpen, Outlook.OlAttachmentType.olByValue, Type.Missing, Type.Missing);
        }

        private void DoSaveMailItemFolder(Outlook._MailItem mailItem, ADXOlForm1 olForm)
        {
            if (olForm.folder != null)
                try
                {
                    Outlook._MailItem copiedMailItem = mailItem.Copy() as Outlook._MailItem;
                    if (copiedMailItem != null)
                        try
                        {
                            Outlook.MAPIFolder fld = copiedMailItem.Parent as Outlook.MAPIFolder;
                            if (olForm.folder.EntryID == fld.EntryID)
                                copiedMailItem.Save();
                            else
                                copiedMailItem.Move(olForm.folder);
                        }
                        finally
                        {
                            Marshal.ReleaseComObject(copiedMailItem);
                        }
                }
                finally
                {
                    Marshal.ReleaseComObject(olForm.folder);
                }
        }

        private void DoSaveMailItemFile(Outlook._MailItem mailItem, ADXOlForm1 olForm)
        {
            string pathFileSave = olForm.textBoxSaveMailItemFile.Text;
            mailItem.SaveAs(pathFileSave, Outlook.OlSaveAsType.olMSG);
        }
    }
}

